#include <spaceConsumer.hpp>

#include <ctime>
#include <boost/random/mersenne_twister.hpp>
#include <boost/random/uniform_int_distribution.hpp>

namespace SRCH=searchTime;

namespace
{
  boost::random::mt19937 spaceGen( std::time( 0 ) );
}

SRCH::spaceConsumer::spaceConsumer()
{
  boost::random::uniform_int_distribution<> uniDist( 0, AMOUNTOFSPACE );
  for( std::uint32_t i = 0; i < AMOUNTOFSPACE; ++i )
    this->space[i] = uniDist( spaceGen );
}

SRCH::spaceConsumer::spaceConsumer( const spaceConsumer& copy )
{
  std::copy( copy.space, (copy.space + AMOUNTOFSPACE), this->space );
}

SRCH::spaceConsumer::spaceConsumer( spaceConsumer&& moveFrom )
{
  std::copy( moveFrom.space, (moveFrom.space + AMOUNTOFSPACE), this->space );
}

SRCH::spaceConsumer::~spaceConsumer()
{
}

SRCH::spaceConsumer& SRCH::spaceConsumer::operator=( const spaceConsumer& rhs )
{
  if( this == &rhs )
    return( *this );
  std::copy( rhs.space, (rhs.space + AMOUNTOFSPACE), this->space );
  return( *this );
}

SRCH::spaceConsumer& SRCH::spaceConsumer::operator=( spaceConsumer&& rhs )
{
  if( this == &rhs )
    return( *this );
  std::copy( rhs.space, (rhs.space + AMOUNTOFSPACE), this->space );
  return( *this );
}

std::uint32_t SRCH::spaceConsumer::GetAmountOfSpace( void ) const
{
  return( AMOUNTOFSPACE );
}
